<?php

/* --------------------------------------------------------------
   ProductQuestionController.inc.php 2016-04-04 gm
   Gambio GmbH
   http://www.gambio.de
   Copyright (c) 2016 Gambio GmbH
   Released under the GNU General Public License (Version 2)
   [http://www.gnu.org/licenses/gpl-2.0.html]
   -------------------------------------------------------------- 
*/

/**
 * Class ProductQuestionController
 * 
 * @extends    HttpViewController
 * @category   System
 * @package    HttpViewControllers
 */
class ProductQuestionController extends HttpViewController
{
	
	public function actionDefault()
	{		
		$productQuestion = $this->_getView();
		
		$response = [
			'success' => true,
		    'content' => $productQuestion->get_html()
		];
		
		return MainFactory::create('JsonHttpControllerResponse', $response);
	}
	
	
	public function actionSend()
	{
		$productQuestion = $this->_getView();
		
		$productQuestion->setPost($_POST);
		$productQuestion->setName($_POST['name']);
		$productQuestion->setEmail($_POST['email']);
		$productQuestion->setMessage($_POST['message']);
		
		$response = [
			'success' => true,
			'content' => $productQuestion->get_html()
		];
		
		return MainFactory::create('JsonHttpControllerResponse', $response);
	}
	
	
	/**
	 * @return \TellAFriendContentView
	 */
	protected function _getView()
	{
		$captcha = MainFactory::create_object('Captcha');
		$productQuestion = MainFactory::create_object('TellAFriendContentView');
		
		$productQuestion->set_content_template('module/product_question.html');
		$productQuestion->set_flat_assigns(false);
		
		$productQuestion->setProductsId((int)$_GET['productId']);
		$productQuestion->setCaptchaObject($_SESSION['captcha_object'] = &$captcha);
		$productQuestion->setCustomerId((int)$_SESSION['customer_id']);
		$productQuestion->setCustomerFirstName($_SESSION['customer_first_name']);
		$productQuestion->setCustomerLastName($_SESSION['customer_last_name']);
		$productQuestion->setLanguagesId((int)$_SESSION['languages_id']);
		
		return $productQuestion;
	}
}